; ====================================================;
;                                                     ;
;     winioctl.inc for EC v2 Fasm visual projects     ;
;                   (version 1.0.0)                   ;
;                                                     ;
;            Copyright  Ramon Sala - 2022            ;
;                                                     ;
; ====================================================;

if ~defined WINTRUST_INC
define WINTRUST_INC 1

WINIOCTL_H_REQVER                               equ     100

GUID_DiskClassGuid                              equ     <053F56307H, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_CdRomClassGuid                             equ     <053F56308H, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_PartitionClassGuid                         equ     <053F5630aH, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_TapeClassGuid                              equ     <053F5630bH, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_WriteOnceDiskClassGuid                     equ     <053F5630cH, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_VolumeClassGuid                            equ     <053F5630dH, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_MediumChangerClassGuid                     equ     <053F56310H, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_FloppyClassGuid                            equ     <053F56311H, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_CdChangerClassGuid                         equ     <053F56312H, 0B6BFH, 011D0H, <094H, 0F2H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>
GUID_StoragePortClassGuid                       equ     <02ACCFE60H, 0C130H, 011D2H, <0B0H, 082H, 000H, 0A0H, 0C9H, 01EH, 0FBH, 08BH>>

GUID_GUID_CLASS_COMPORT                         equ     <086E0D1E0H, 08089H, 011D0H, <09CH, 0E4H, 008H, 000H, 03EH, 030H, 01FH, 073H>>
GUID_GUID_SERENUM_BUS_ENUMERATOR                equ     <04D36E978H, 0E325H, 011CEH, <0BFH, 0C1H, 008H, 000H, 02BH, 0E1H, 003H, 018H>>

if ~defined FILE_DEVICE_BEEP
    FILE_DEVICE_BEEP                            equ     000000001H
    FILE_DEVICE_CD_ROM                          equ     000000002H
    FILE_DEVICE_CD_ROM_FILE_SYSTEM              equ     000000003H
    FILE_DEVICE_CONTROLLER                      equ     000000004H
    FILE_DEVICE_DATALINK                        equ     000000005H
    FILE_DEVICE_DFS                             equ     000000006H
    FILE_DEVICE_DISK                            equ     000000007H
    FILE_DEVICE_DISK_FILE_SYSTEM                equ     000000008H
    FILE_DEVICE_FILE_SYSTEM                     equ     000000009H
    FILE_DEVICE_INPORT_PORT                     equ     00000000AH
    FILE_DEVICE_KEYBOARD                        equ     00000000BH
    FILE_DEVICE_MAILSLOT                        equ     00000000CH
    FILE_DEVICE_MIDI_IN                         equ     00000000DH
    FILE_DEVICE_MIDI_OUT                        equ     00000000EH
    FILE_DEVICE_MOUSE                           equ     00000000FH
    FILE_DEVICE_MULTI_UNC_PROVIDER              equ     000000010H
    FILE_DEVICE_NAMED_PIPE                      equ     000000011H
    FILE_DEVICE_NETWORK                         equ     000000012H
    FILE_DEVICE_NETWORK_BROWSER                 equ     000000013H
    FILE_DEVICE_NETWORK_FILE_SYSTEM             equ     000000014H
    FILE_DEVICE_NULL                            equ     000000015H
    FILE_DEVICE_PARALLEL_PORT                   equ     000000016H
    FILE_DEVICE_PHYSICAL_NETCARD                equ     000000017H
    FILE_DEVICE_PRINTER                         equ     000000018H
    FILE_DEVICE_SCANNER                         equ     000000019H
    FILE_DEVICE_SERIAL_MOUSE_PORT               equ     00000001AH
    FILE_DEVICE_SERIAL_PORT                     equ     00000001BH
    FILE_DEVICE_SCREEN                          equ     00000001CH
    FILE_DEVICE_SOUND                           equ     00000001DH
    FILE_DEVICE_STREAMS                         equ     00000001EH
    FILE_DEVICE_TAPE                            equ     00000001FH
    FILE_DEVICE_TAPE_FILE_SYSTEM                equ     000000020H
    FILE_DEVICE_TRANSPORT                       equ     000000021H
    FILE_DEVICE_UNKNOWN                         equ     000000022H
    FILE_DEVICE_VIDEO                           equ     000000023H
    FILE_DEVICE_VIRTUAL_DISK                    equ     000000024H
    FILE_DEVICE_WAVE_IN                         equ     000000025H
    FILE_DEVICE_WAVE_OUT                        equ     000000026H
    FILE_DEVICE_8042_PORT                       equ     000000027H
    FILE_DEVICE_NETWORK_REDIRECTOR              equ     000000028H
    FILE_DEVICE_BATTERY                         equ     000000029H
    FILE_DEVICE_BUS_EXTENDER                    equ     00000002AH
    FILE_DEVICE_MODEM                           equ     00000002BH
    FILE_DEVICE_VDM                             equ     00000002CH
    FILE_DEVICE_MASS_STORAGE                    equ     00000002DH
    FILE_DEVICE_SMB                             equ     00000002EH
    FILE_DEVICE_KS                              equ     00000002FH
    FILE_DEVICE_CHANGER                         equ     000000030H
    if ~defined FILE_DEVICE_SMARTCARD
        FILE_DEVICE_SMARTCARD                   equ     000000031H
    end if
    FILE_DEVICE_ACPI                            equ     000000032H
    FILE_DEVICE_DVD                             equ     000000033H
    FILE_DEVICE_FULLSCREEN_VIDEO                equ     000000034H
    FILE_DEVICE_DFS_FILE_SYSTEM                 equ     000000035H
    FILE_DEVICE_DFS_VOLUME                      equ     000000036H
    FILE_DEVICE_SERENUM                         equ     000000037H
    FILE_DEVICE_TERMSRV                         equ     000000038H
    FILE_DEVICE_KSEC                            equ     000000039H
    FILE_DEVICE_FIPS                            equ     00000003AH
    FILE_DEVICE_INFINIBAND                      equ     00000003BH
    FILE_DEVICE_VMBUS                           equ     00000003EH
    FILE_DEVICE_CRYPT_PROVIDER                  equ     00000003FH
    FILE_DEVICE_WPD                             equ     000000040H
    FILE_DEVICE_BLUETOOTH                       equ     000000041H
    FILE_DEVICE_MT_COMPOSITE                    equ     000000042H
    FILE_DEVICE_MT_TRANSPORT                    equ     000000043H
    FILE_DEVICE_BIOMETRIC                       equ     000000044H
    FILE_DEVICE_PMI                             equ     000000045H
end if

METHOD_BUFFERED                                 equ     0
METHOD_IN_DIRECT                                equ     1
METHOD_OUT_DIRECT                               equ     2
METHOD_NEITHER                                  equ     3

FILE_ANY_ACCESS                                 equ     0
FILE_SPECIAL_ACCESS                             equ     FILE_ANY_ACCESS
FILE_READ_ACCESS                                equ     00001H
FILE_WRITE_ACCESS                               equ     00002H

IOCTL_STORAGE_BASE                              equ     FILE_DEVICE_MASS_STORAGE
IOCTL_STORAGE_CHECK_VERIFY                      equ     (IOCTL_STORAGE_BASE shl 16) or (00200H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_CHECK_VERIFY2                     equ     (IOCTL_STORAGE_BASE shl 16) or (00200H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_MEDIA_REMOVAL                     equ     (IOCTL_STORAGE_BASE shl 16) or (00201H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_EJECT_MEDIA                       equ     (IOCTL_STORAGE_BASE shl 16) or (00202H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_LOAD_MEDIA                        equ     (IOCTL_STORAGE_BASE shl 16) or (00203H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_LOAD_MEDIA2                       equ     (IOCTL_STORAGE_BASE shl 16) or (00203H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_RESERVE                           equ     (IOCTL_STORAGE_BASE shl 16) or (00204H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_RELEASE                           equ     (IOCTL_STORAGE_BASE shl 16) or (00205H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_FIND_NEW_DEVICES                  equ     (IOCTL_STORAGE_BASE shl 16) or (00206H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_EJECTION_CONTROL                  equ     (IOCTL_STORAGE_BASE shl 16) or (00250H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_MCN_CONTROL                       equ     (IOCTL_STORAGE_BASE shl 16) or (00251H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_GET_MEDIA_TYPES                   equ     (IOCTL_STORAGE_BASE shl 16) or (00300H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_GET_MEDIA_TYPES_EX                equ     (IOCTL_STORAGE_BASE shl 16) or (00301H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_RESET_BUS                         equ     (IOCTL_STORAGE_BASE shl 16) or (00400H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_RESET_DEVICE                      equ     (IOCTL_STORAGE_BASE shl 16) or (00401H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_GET_DEVICE_NUMBER                 equ     (IOCTL_STORAGE_BASE shl 16) or (00420H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_PREDICT_FAILURE                   equ     (IOCTL_STORAGE_BASE shl 16) or (00440H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_BREAK_RESERVATION                 equ     (IOCTL_STORAGE_BASE shl 16) or (00405H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_STORAGE_PERSISTENT_RESERVE_IN             equ     (IOCTL_STORAGE_BASE shl 16) or (00406H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_STORAGE_PERSISTENT_RESERVE_OUT            equ     (IOCTL_STORAGE_BASE shl 16) or (00407H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_STORAGE_READ_CAPACITY                     equ     (IOCTL_STORAGE_BASE shl 16) or (00450H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_QUERY_PROPERTY                    equ     (IOCTL_STORAGE_BASE shl 16) or (00500H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_STORAGE_GET_BC_PROPERTIES                 equ     (IOCTL_STORAGE_BASE shl 16) or (00600H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_STORAGE_ALLOCATE_BC_STREAM                equ     (IOCTL_STORAGE_BASE shl 16) or (00601H shl 2) or METHOD_BUFFERED or ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) shl 14)
IOCTL_STORAGE_FREE_BC_STREAM                    equ     (IOCTL_STORAGE_BASE shl 16) or (00602H shl 2) or METHOD_BUFFERED or ((FILE_READ_ACCESS or FILE_WRITE_ACCESS) shl 14)
IOCTL_STORAGE_CHECK_PRIORITY_HINT_SUPPORT       equ     (IOCTL_STORAGE_BASE shl 16) or (00620H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)

OBSOLETE_IOCTL_STORAGE_RESET_BUS                equ     (IOCTL_STORAGE_BASE shl 16) or (00400H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
OBSOLETE_IOCTL_STORAGE_RESET_DEVICE             equ     (IOCTL_STORAGE_BASE shl 16) or (00401H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)

IOCTL_DISK_BASE                                 equ     FILE_DEVICE_DISK
IOCTL_DISK_GET_DRIVE_GEOMETRY                   equ     (IOCTL_DISK_BASE shl 16) or (00000H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_GET_PARTITION_INFO                   equ     (IOCTL_DISK_BASE shl 16) or (00001H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_SET_PARTITION_INFO                   equ     (IOCTL_DISK_BASE shl 16) or (00002H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_GET_DRIVE_LAYOUT                     equ     (IOCTL_DISK_BASE shl 16) or (00003H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_SET_DRIVE_LAYOUT                     equ     (IOCTL_DISK_BASE shl 16) or (00004H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_VERIFY                               equ     (IOCTL_DISK_BASE shl 16) or (00005H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_FORMAT_TRACKS                        equ     (IOCTL_DISK_BASE shl 16) or (00006H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_REASSIGN_BLOCKS                      equ     (IOCTL_DISK_BASE shl 16) or (00007H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_PERFORMANCE                          equ     (IOCTL_DISK_BASE shl 16) or (00008H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_IS_WRITABLE                          equ     (IOCTL_DISK_BASE shl 16) or (00009H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_LOGGING                              equ     (IOCTL_DISK_BASE shl 16) or (0000AH shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_FORMAT_TRACKS_EX                     equ     (IOCTL_DISK_BASE shl 16) or (0000BH shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_HISTOGRAM_STRUCTURE                  equ     (IOCTL_DISK_BASE shl 16) or (0000CH shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_HISTOGRAM_DATA                       equ     (IOCTL_DISK_BASE shl 16) or (0000DH shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_HISTOGRAM_RESET                      equ     (IOCTL_DISK_BASE shl 16) or (0000EH shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_REQUEST_STRUCTURE                    equ     (IOCTL_DISK_BASE shl 16) or (0000FH shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_REQUEST_DATA                         equ     (IOCTL_DISK_BASE shl 16) or (00010H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_CONTROLLER_NUMBER                    equ     (IOCTL_DISK_BASE shl 16) or (00011H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
SMART_GET_VERSION                               equ     (IOCTL_DISK_BASE shl 16) or (00020H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
SMART_SEND_DRIVE_COMMAND                        equ     (IOCTL_DISK_BASE shl 16) or (00021H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
SMART_RCV_DRIVE_DATA                            equ     (IOCTL_DISK_BASE shl 16) or (00022H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_UPDATE_DRIVE_SIZE                    equ     (IOCTL_DISK_BASE shl 16) or (00032H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_GROW_PARTITION                       equ     (IOCTL_DISK_BASE shl 16) or (00034H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_GET_CACHE_INFORMATION                equ     (IOCTL_DISK_BASE shl 16) or (00035H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_SET_CACHE_INFORMATION                equ     (IOCTL_DISK_BASE shl 16) or (00036H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_DELETE_DRIVE_LAYOUT                  equ     (IOCTL_DISK_BASE shl 16) or (00040H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_FORMAT_DRIVE                         equ     (IOCTL_DISK_BASE shl 16) or (000F3H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_DISK_SENSE_DEVICE                         equ     (IOCTL_DISK_BASE shl 16) or (000F8H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_CHECK_VERIFY                         equ     (IOCTL_DISK_BASE shl 16) or (00200H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_MEDIA_REMOVAL                        equ     (IOCTL_DISK_BASE shl 16) or (00201H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_EJECT_MEDIA                          equ     (IOCTL_DISK_BASE shl 16) or (00202H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_LOAD_MEDIA                           equ     (IOCTL_DISK_BASE shl 16) or (00203H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_RESERVE                              equ     (IOCTL_DISK_BASE shl 16) or (00204H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_RELEASE                              equ     (IOCTL_DISK_BASE shl 16) or (00205H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_FIND_NEW_DEVICES                     equ     (IOCTL_DISK_BASE shl 16) or (00206H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_DISK_GET_MEDIA_TYPES                      equ     (IOCTL_DISK_BASE shl 16) or (00300H shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_DISK_GET_WRITE_CACHE_STATE                equ     (IOCTL_DISK_BASE shl 16) or (00037H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
OBSOLETE_DISK_GET_WRITE_CACHE_STATE             equ     (IOCTL_DISK_BASE shl 16) or (00037H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)


IOCTL_CHANGER_BASE                              equ     FILE_DEVICE_CHANGER
IOCTL_CHANGER_GET_PARAMETERS                    equ     (IOCTL_CHANGER_BASE shl 16) or (00000H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_CHANGER_GET_STATUS                        equ     (IOCTL_CHANGER_BASE shl 16) or (00001H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_CHANGER_GET_PRODUCT_DATA                  equ     (IOCTL_CHANGER_BASE shl 16) or (00002H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_CHANGER_SET_ACCESS                        equ     (IOCTL_CHANGER_BASE shl 16) or (00004H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_CHANGER_GET_ELEMENT_STATUS                equ     (IOCTL_CHANGER_BASE shl 16) or (00005H shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_CHANGER_INITIALIZE_ELEMENT_STATUS         equ     (IOCTL_CHANGER_BASE shl 16) or (00006H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_CHANGER_SET_POSITION                      equ     (IOCTL_CHANGER_BASE shl 16) or (00007H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_CHANGER_EXCHANGE_MEDIUM                   equ     (IOCTL_CHANGER_BASE shl 16) or (00008H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_CHANGER_MOVE_MEDIUM                       equ     (IOCTL_CHANGER_BASE shl 16) or (00009H shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_CHANGER_REINITIALIZE_TRANSPORT            equ     (IOCTL_CHANGER_BASE shl 16) or (0000AH shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)
IOCTL_CHANGER_QUERY_VOLUME_TAGS                 equ     (IOCTL_CHANGER_BASE shl 16) or (0000BH shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
IOCTL_VOLUME_IS_CLUSTERED                       equ     (IOCTL_VOLUME_BASE shl 16) or (0000CH shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)

RECOVERED_WRITES_VALID                          equ     000000001H
UNRECOVERED_WRITES_VALID                        equ     000000002H
RECOVERED_READS_VALID                           equ     000000004H
UNRECOVERED_READS_VALID                         equ     000000008H
WRITE_COMPRESSION_INFO_VALID                    equ     000000010H
READ_COMPRESSION_INFO_VALID                     equ     000000020H

TAPE_RETURN_STATISTICS                          equ     0
TAPE_RETURN_ENV_INFO                            equ     1
TAPE_RESET_STATISTICS                           equ     2

MEDIA_ERASEABLE                                 equ     000000001H
MEDIA_WRITE_ONCE                                equ     000000002H
MEDIA_READ_ONLY                                 equ     000000004H
MEDIA_READ_WRITE                                equ     000000008H

MEDIA_WRITE_PROTECTED                           equ     000000100H
MEDIA_CURRENTLY_MOUNTED                         equ     080000000H

DDS_4mm                                         equ     32
MiniQic                                         equ     33
Travan                                          equ     34
QIC                                             equ     35
MP_8mm                                          equ     36
AME_8mm                                         equ     37
AIT1_8mm                                        equ     38
DLT                                             equ     39
NCTP                                            equ     40
IBM_3480                                        equ     41
IBM_3490E                                       equ     42
IBM_Magstar_3590                                equ     43
IBM_Magstar_MP                                  equ     44
STK_DATA_D3                                     equ     45
SONY_DTF                                        equ     46
DV_6mm                                          equ     47
DMI                                             equ     48
SONY_D2                                         equ     49
CLEANER_CARTRIDGE                               equ     50
CD_ROM                                          equ     51
CD_R                                            equ     52
CD_RW                                           equ     53
DVD_ROM                                         equ     54
DVD_R                                           equ     55
DVD_RW                                          equ     56
MO_3_RW                                         equ     57
MO_5_WO                                         equ     58
MO_5_RW                                         equ     59
MO_5_LIMDOW                                     equ     60
PC_5_WO                                         equ     61
PC_5_RW                                         equ     62
PD_5_RW                                         equ     63
ABL_5_WO                                        equ     64
PINNACLE_APEX_5_RW                              equ     65
SONY_12_WO                                      equ     66
PHILIPS_12_WO                                   equ     67
HITACHI_12_WO                                   equ     68
CYGNET_12_WO                                    equ     69
KODAK_14_WO                                     equ     70
MO_NFR_525                                      equ     71
NIKON_12_RW                                     equ     72
IOMEGA_ZIP                                      equ     73
IOMEGA_JAZ                                      equ     74
SYQUEST_EZ135                                   equ     75
SYQUEST_EZFLYER                                 equ     76
SYQUEST_SYJET                                   equ     77
AVATAR_F2                                       equ     78
MP2_8mm                                         equ     79
DST_S                                           equ     80
DST_M                                           equ     81
DST_L                                           equ     82
VXATape_1                                       equ     83
VXATape_2                                       equ     84
STK_9840                                        equ     85
STK_EAGLE                                       equ     85
LTO_Ultrium                                     equ     86
LTO_Accelis                                     equ     87
DVD_RAM                                         equ     88
AIT_8mm                                         equ     89
ADR_1                                           equ     90
ADR_2                                           equ     91
STK_9940                                        equ     92
SAIT                                            equ     93
VXATape                                         equ     94

BusTypeUnknown                                  equ     0
BusTypeScsi                                     equ     1
BusTypeAtapi                                    equ     2
BusTypeAta                                      equ     3
BusType1394                                     equ     4
BusTypeSsa                                      equ     5
BusTypeFibre                                    equ     6
BusTypeUsb                                      equ     7
BusTypeRAID                                     equ     8
BusTypeiScsi                                    equ     9
BusTypeSas                                      equ     10
BusTypeSata                                     equ     11
BusTypeSd                                       equ     12
BusTypeMmc                                      equ     13
BusTypeMax                                      equ     14
BusTypeMaxReserved                              equ     07FH

PARTITION_ENTRY_UNUSED                          equ     000H
PARTITION_FAT_12                                equ     001H
PARTITION_XENIX_1                               equ     002H
PARTITION_XENIX_2                               equ     003H
PARTITION_FAT_16                                equ     004H
PARTITION_EXTENDED                              equ     005H
PARTITION_HUGE                                  equ     006H
PARTITION_IFS                                   equ     007H
PARTITION_FAT32                                 equ     00BH
PARTITION_FAT32_XINT13                          equ     00CH
PARTITION_XINT13                                equ     00EH
PARTITION_XINT13_EXTENDED                       equ     00FH
PARTITION_PREP                                  equ     041H
PARTITION_LDM                                   equ     042H
PARTITION_UNIX                                  equ     063H
PARTITION_NTFT                                  equ     080H
VALID_NTFT                                      equ     0C0H

HIST_NO_OF_BUCKETS                              equ     24

HISTOGRAM_BUCKET_SIZE                           equ     SizeOf HISTOGRAM_BUCKET
DISK_HISTOGRAM_SIZE                             equ     SizeOf DISK_HISTOGRAM

DISK_LOGGING_START                              equ     0
DISK_LOGGING_STOP                               equ     1
DISK_LOGGING_DUMP                               equ     2
DISK_BINNING                                    equ     3

StoragePortCodeSetReserved                      equ     0
StoragePortCodeSetStorport                      equ     1
StoragePortCodeSetSCSIport                      equ     2

StorageIdCodeSetReserved                        equ     0
StorageIdCodeSetBinary                          equ     1
StorageIdCodeSetAscii                           equ     2
StorageIdCodeSetUtf8                            equ     3

StorageIdTypeVendorSpecific                     equ     0
StorageIdTypeVendorId                           equ     1
StorageIdTypeEUI64                              equ     2
StorageIdTypeFCPHName                           equ     3
StorageIdTypePortRelative                       equ     4
StorageIdTypeTargetPortGroup                    equ     5
StorageIdTypeLogicalUnitGroup                   equ     6
StorageIdTypeMD5LogicalUnitIdentifier           equ     7
StorageIdTypeScsiNameString                     equ     8

StorageIdTypeNAA                                equ     StorageIdTypeFCPHName

StorageIdNAAFormatIEEEExtended                  equ     2
StorageIdNAAFormatIEEERegistered                equ     3
StorageIdNAAFormatIEEEERegisteredExtended       equ     5

StorageIdAssocDevice                            equ     0
StorageIdAssocPort                              equ     1
StorageIdAssocTarget                            equ     2

WriteCacheTypeUnknown                           equ     0
WriteCacheTypeNone                              equ     1
WriteCacheTypeWriteBack                         equ     2
WriteCacheTypeWriteThrough                      equ     3

WriteCacheEnableUnknown                         equ     0
WriteCacheDisabled                              equ     1
WriteCacheEnabled                               equ     2

WriteCacheChangeUnknown                         equ     0
WriteCacheNotChangeable                         equ     1
WriteCacheChangeable                            equ     2

WriteThroughUnknown                             equ     0
WriteThroughNotSupported                        equ     1
WriteThroughSupported                           equ     2

F5_1Pt2_512                                     equ     1
F3_1Pt44_512                                    equ     2
F3_2Pt88_512                                    equ     3
F3_20Pt8_512                                    equ     4
F3_720_512                                      equ     5
F5_360_512                                      equ     6
F5_320_512                                      equ     7
F5_320_1024                                     equ     8
F5_180_512                                      equ     9
F5_160_512                                      equ     10
RemovableMedia                                  equ     11
FixedMedia                                      equ     12
F3_120M_512                                     equ     13
F3_640_512                                      equ     14
F5_640_512                                      equ     15
F5_720_512                                      equ     16
F3_1Pt2_512                                     equ     17
F3_1Pt23_1024                                   equ     18
F5_1Pt23_1024                                   equ     19
F3_128Mb_512                                    equ     20
F3_230Mb_512                                    equ     21
F8_256_128                                      equ     22
F3_200Mb_512                                    equ     23
F3_240M_512                                     equ     24
F3_32M_512                                      equ     25

WMI_DISK_GEOMETRY_GUID                          equ     <025007F51H, 057C2H, 011D1H, <0A5H, 028H, 00H, 0A0H, 0C9H, 06H,029H, 010H>>

PARTITION_STYLE_MBR                             equ     0
PARTITION_STYLE_GPT                             equ     1
PARTITION_STYLE_RAW                             equ     2

GPT_ATTRIBUTE_PLATFORM_REQUIRED                 equ     00000000000000001H
GPT_BASIC_DATA_ATTRIBUTE_NO_DRIVE_LETTER        equ     08000000000000000H
GPT_BASIC_DATA_ATTRIBUTE_HIDDEN                 equ     04000000000000000H
GPT_BASIC_DATA_ATTRIBUTE_SHADOW_COPY            equ     02000000000000000H
GPT_BASIC_DATA_ATTRIBUTE_READ_ONLY              equ     01000000000000000H

DetectNone                                      equ     0
DetectInt13                                     equ     1
DetectExInt13                                   equ     2

EqualPriority                                   equ     0
KeepPrefetchedData                              equ     1
KeepReadData                                    equ     2

DiskWriteCacheNormal                            equ     0
DiskWriteCacheForceDisable                      equ     1
DiskWriteCacheDisableNotSupported               equ     2

CAP_ATA_ID_CMD                                  equ     1
CAP_ATAPI_ID_CMD                                equ     2
CAP_SMART_CMD                                   equ     4

ATAPI_ID_CMD                                    equ     0A1H
ID_CMD                                          equ     0ECH
SMART_CMD                                       equ     0B0H

SMART_CYL_LOW                                   equ     04FH
SMART_CYL_HI                                    equ     0C2H

SMART_NO_ERROR                                  equ     0
SMART_IDE_ERROR                                 equ     1
SMART_INVALID_FLAG                              equ     2
SMART_INVALID_COMMAND                           equ     3
SMART_INVALID_BUFFER                            equ     4
SMART_INVALID_DRIVE                             equ     5
SMART_INVALID_IOCTL                             equ     6
SMART_ERROR_NO_MEM                              equ     7
SMART_INVALID_REGISTER                          equ     8
SMART_NOT_SUPPORTED                             equ     9
SMART_NO_IDE_DEVICE                             equ     10

READ_ATTRIBUTE_BUFFER_SIZE                      equ     512
IDENTIFY_BUFFER_SIZE                            equ     512
READ_THRESHOLD_BUFFER_SIZE                      equ     512

READ_ATTRIBUTES                                 equ     0D0H
READ_THRESHOLDS                                 equ     0D1H
ENABLE_DISABLE_AUTOSAVE                         equ     0D2H
SAVE_ATTRIBUTE_VALUES                           equ     0D3H
EXECUTE_OFFLINE_DIAGS                           equ     0D4H
ENABLE_SMART                                    equ     0D8H
DISABLE_SMART                                   equ     0D9H
RETURN_SMART_STATUS                             equ     0DAH
ENABLE_DISABLE_AUTO_OFFLINE                     equ     0DBH

MAX_VOLUME_ID_SIZE                              equ     36
MAX_VOLUME_TEMPLATE_SIZE                        equ     40

VENDOR_ID_LENGTH                                equ     8
PRODUCT_ID_LENGTH                               equ     16
REVISION_LENGTH                                 equ     4
SERIAL_NUMBER_LENGTH                            equ     32

AllElements                                     equ     0
ChangerTransport                                equ     1
ChangerSlot                                     equ     2
ChangerIEPort                                   equ     3
ChangerDrive                                    equ     4
ChangerDoor                                     equ     5
ChangerKeypad                                   equ     6
ChangerMaxElement                               equ     7

CHANGER_BAR_CODE_SCANNER_INSTALLED              equ     000000001H
CHANGER_INIT_ELEM_STAT_WITH_RANGE               equ     000000002H
CHANGER_CLOSE_IEPORT                            equ     000000004H
CHANGER_OPEN_IEPORT                             equ     000000008H
CHANGER_STATUS_NON_VOLATILE                     equ     000000010H
CHANGER_EXCHANGE_MEDIA                          equ     000000020H
CHANGER_CLEANER_SLOT                            equ     000000040H
CHANGER_LOCK_UNLOCK                             equ     000000080H
CHANGER_CARTRIDGE_MAGAZINE                      equ     000000100H
CHANGER_MEDIUM_FLIP                             equ     000000200H
CHANGER_POSITION_TO_ELEMENT                     equ     000000400H
CHANGER_REPORT_IEPORT_STATE                     equ     000000800H
CHANGER_STORAGE_DRIVE                           equ     000001000H
CHANGER_STORAGE_IEPORT                          equ     000002000H
CHANGER_STORAGE_SLOT                            equ     000004000H
CHANGER_STORAGE_TRANSPORT                       equ     000008000H
CHANGER_DRIVE_CLEANING_REQUIRED                 equ     000010000H
CHANGER_PREDISMOUNT_EJECT_REQUIRED              equ     000020000H
CHANGER_CLEANER_ACCESS_NOT_VALID                equ     000040000H
CHANGER_PREMOUNT_EJECT_REQUIRED                 equ     000080000H
CHANGER_VOLUME_IDENTIFICATION                   equ     000100000H
CHANGER_VOLUME_SEARCH                           equ     000200000H
CHANGER_VOLUME_ASSERT                           equ     000400000H
CHANGER_VOLUME_REPLACE                          equ     000800000H
CHANGER_VOLUME_UNDEFINE                         equ     001000000H
CHANGER_SERIAL_NUMBER_VALID                     equ     004000000H
CHANGER_DEVICE_REINITIALIZE_CAPABLE             equ     008000000H
CHANGER_KEYPAD_ENABLE_DISABLE                   equ     010000000H
CHANGER_DRIVE_EMPTY_ON_DOOR_ACCESS              equ     020000000H
CHANGER_RESERVED_BIT                            equ     080000000H
CHANGER_PREDISMOUNT_ALIGN_TO_SLOT               equ     080000001H
CHANGER_PREDISMOUNT_ALIGN_TO_DRIVE              equ     080000002H
CHANGER_CLEANER_AUTODISMOUNT                    equ     080000004H
CHANGER_TRUE_EXCHANGE_CAPABLE                   equ     080000008H
CHANGER_SLOTS_USE_TRAYS                         equ     080000010H
CHANGER_RTN_MEDIA_TO_ORIGINAL_ADDR              equ     080000020H
CHANGER_CLEANER_OPS_NOT_SUPPORTED               equ     080000040H
CHANGER_IEPORT_USER_CONTROL_OPEN                equ     080000080H
CHANGER_IEPORT_USER_CONTROL_CLOSE               equ     080000100H
CHANGER_MOVE_EXTENDS_IEPORT                     equ     080000200H
CHANGER_MOVE_RETRACTS_IEPORT                    equ     080000400H

CHANGER_TO_TRANSPORT                            equ     001H
CHANGER_TO_SLOT                                 equ     002H
CHANGER_TO_IEPORT                               equ     004H
CHANGER_TO_DRIVE                                equ     008H

LOCK_UNLOCK_IEPORT                              equ     001H
LOCK_UNLOCK_DOOR                                equ     002H
LOCK_UNLOCK_KEYPAD                              equ     004H

LOCK_ELEMENT                                    equ     0
UNLOCK_ELEMENT                                  equ     1
EXTEND_IEPORT                                   equ     2
RETRACT_IEPORT                                  equ     3

ELEMENT_STATUS_FULL                             equ     000000001H
ELEMENT_STATUS_IMPEXP                           equ     000000002H
ELEMENT_STATUS_EXCEPT                           equ     000000004H
ELEMENT_STATUS_ACCESS                           equ     000000008H
ELEMENT_STATUS_EXENAB                           equ     000000010H
ELEMENT_STATUS_INENAB                           equ     000000020H

ELEMENT_STATUS_LUN_VALID                        equ     000001000H
ELEMENT_STATUS_ID_VALID                         equ     000002000H
ELEMENT_STATUS_NOT_BUS                          equ     000008000H
ELEMENT_STATUS_INVERT                           equ     000400000H
ELEMENT_STATUS_SVALID                           equ     000800000H

ELEMENT_STATUS_PVOLTAG                          equ     010000000H
ELEMENT_STATUS_AVOLTAG                          equ     020000000H

ERROR_LABEL_UNREADABLE                          equ     000000001H
ERROR_LABEL_QUESTIONABLE                        equ     000000002H
ERROR_SLOT_NOT_PRESENT                          equ     000000004H
ERROR_DRIVE_NOT_INSTALLED                       equ     000000008H
ERROR_TRAY_MALFUNCTION                          equ     000000010H
ERROR_INIT_STATUS_NEEDED                        equ     000000011H
ERROR_UNHANDLED_ERROR                           equ     0FFFFFFFFH

SEARCH_ALL                                      equ     00H
SEARCH_PRIMARY                                  equ     01H
SEARCH_ALTERNATE                                equ     02H
SEARCH_ALL_NO_SEQ                               equ     04H
SEARCH_PRI_NO_SEQ                               equ     05H
SEARCH_ALT_NO_SEQ                               equ     06H

ASSERT_PRIMARY                                  equ     08H
ASSERT_ALTERNATE                                equ     09H

REPLACE_PRIMARY                                 equ     0AH
REPLACE_ALTERNATE                               equ     0BH

UNDEFINE_PRIMARY                                equ     0CH
UNDEFINE_ALTERNATE                              equ     0DH

DeviceProblemNone                               equ     0
DeviceProblemHardware                           equ     1
DeviceProblemCHMError                           equ     2
DeviceProblemDoorOpen                           equ     3
DeviceProblemCalibrationError                   equ     4
DeviceProblemTargetFailure                      equ     5
DeviceProblemCHMMoveError                       equ     6
DeviceProblemCHMZeroError                       equ     7
DeviceProblemCartridgeInsertError               equ     8
DeviceProblemPositionError                      equ     9
DeviceProblemSensorError                        equ     10
DeviceProblemCartridgeEjectError                equ     11
DeviceProblemGripperError                       equ     12
DeviceProblemDriveError                         equ     13

FILE_DEVICE_AVIO                                equ     099H

IOCTL_AVIO_ALLOCATE_STREAM                      equ     (FILE_DEVICE_AVIO shl 16) or (1 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
IOCTL_AVIO_FREE_STREAM                          equ     (FILE_DEVICE_AVIO shl 16) or (2 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
IOCTL_AVIO_MODIFY_STREAM                        equ     (FILE_DEVICE_AVIO shl 16) or (3 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)

IOCTL_SERIAL_LSRMST_INSERT                      equ     (FILE_DEVICE_SERIAL_PORT shl 16) or (31 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_SERENUM_EXPOSE_HARDWARE                   equ     (FILE_DEVICE_SERENUM shl 16) or (128 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_SERENUM_REMOVE_HARDWARE                   equ     (FILE_DEVICE_SERENUM shl 16) or (129 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_SERENUM_PORT_DESC                         equ     (FILE_DEVICE_SERENUM shl 16) or (130 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
IOCTL_SERENUM_GET_PORT_NAME                     equ     (FILE_DEVICE_SERENUM shl 16) or (131 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)

SERIAL_LSRMST_ESCAPE                            equ     0
SERIAL_LSRMST_LSR_DATA                          equ     1
SERIAL_LSRMST_LSR_NODATA                        equ     2
SERIAL_LSRMST_MST                               equ     3

SERIAL_IOC_FCR_FIFO_ENABLE                      equ     000000001H
SERIAL_IOC_FCR_RCVR_RESET                       equ     000000002H
SERIAL_IOC_FCR_XMIT_RESET                       equ     000000004H
SERIAL_IOC_FCR_DMA_MODE                         equ     000000008H
SERIAL_IOC_FCR_RES1                             equ     000000010H
SERIAL_IOC_FCR_RES2                             equ     000000020H
SERIAL_IOC_FCR_RCVR_TRIGGER_LSB                 equ     000000040H
SERIAL_IOC_FCR_RCVR_TRIGGER_MSB                 equ     000000080H

SERIAL_IOC_MCR_DTR                              equ     000000001H
SERIAL_IOC_MCR_RTS                              equ     000000002H
SERIAL_IOC_MCR_OUT1                             equ     000000004H
SERIAL_IOC_MCR_OUT2                             equ     000000008H
SERIAL_IOC_MCR_LOOP                             equ     000000010H

FSCTL_REQUEST_OPLOCK_LEVEL_1                    equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (0 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_REQUEST_OPLOCK_LEVEL_2                    equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (1 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_REQUEST_BATCH_OPLOCK                      equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (2 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_OPLOCK_BREAK_ACKNOWLEDGE                  equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (3 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_OPBATCH_ACK_CLOSE_PENDING                 equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (4 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_OPLOCK_BREAK_NOTIFY                       equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (5 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_LOCK_VOLUME                               equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (6 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_UNLOCK_VOLUME                             equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (7 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_DISMOUNT_VOLUME                           equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (8 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_IS_VOLUME_MOUNTED                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (10 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_IS_PATHNAME_VALID                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (11 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_MARK_VOLUME_DIRTY                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (12 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_QUERY_RETRIEVAL_POINTERS                  equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (14 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_GET_COMPRESSION                           equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (15 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_SET_COMPRESSION                           equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (16 shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
FSCTL_MARK_AS_SYSTEM_HIVE                       equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (19 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_OPLOCK_BREAK_ACK_NO_2                     equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (20 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_INVALIDATE_VOLUMES                        equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (21 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_QUERY_FAT_BPB                             equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (22 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_REQUEST_FILTER_OPLOCK                     equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (23 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_FILESYSTEM_GET_STATISTICS                 equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (24 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_GET_NTFS_VOLUME_DATA                      equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (25 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_GET_NTFS_FILE_RECORD                      equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (26 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_GET_VOLUME_BITMAP                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (27 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_GET_RETRIEVAL_POINTERS                    equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (28 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_MOVE_FILE                                 equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (29 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_IS_VOLUME_DIRTY                           equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (30 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_GET_HFS_INFORMATION                       equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (31 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_ALLOW_EXTENDED_DASD_IO                    equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (32 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_READ_PROPERTY_DATA                        equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (33 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_WRITE_PROPERTY_DATA                       equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (34 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_FIND_FILES_BY_SID                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (35 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_DUMP_PROPERTY_DATA                        equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (37 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_SET_OBJECT_ID                             equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (38 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_GET_OBJECT_ID                             equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (39 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_DELETE_OBJECT_ID                          equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (40 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_SET_REPARSE_POINT                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (41 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_GET_REPARSE_POINT                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (42 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_DELETE_REPARSE_POINT                      equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (43 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_ENUM_USN_DATA                             equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (44 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_SECURITY_ID_CHECK                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (45 shl 2) or METHOD_NEITHER or (FILE_READ_ACCESS shl 14)
FSCTL_READ_USN_JOURNAL                          equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (46 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_SET_OBJECT_ID_EXTENDED                    equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (47 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_CREATE_OR_GET_OBJECT_ID                   equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (48 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_SET_SPARSE                                equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (49 shl 2) or METHOD_BUFFERED or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_SET_ZERO_DATA                             equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (50 shl 2) or METHOD_BUFFERED or (FILE_WRITE_ACCESS shl 14)
FSCTL_QUERY_ALLOCATED_RANGES                    equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (51 shl 2) or METHOD_NEITHER or (FILE_READ_ACCESS shl 14)
FSCTL_ENABLE_UPGRADE                            equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (52 shl 2) or METHOD_BUFFERED or (FILE_WRITE_ACCESS shl 14)
FSCTL_SET_ENCRYPTION                            equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (53 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_ENCRYPTION_FSCTL_IO                       equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (54 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_WRITE_RAW_ENCRYPTED                       equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (55 shl 2) or METHOD_NEITHER or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_READ_RAW_ENCRYPTED                        equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (56 shl 2) or METHOD_NEITHER or (FILE_SPECIAL_ACCESS shl 14)
FSCTL_CREATE_USN_JOURNAL                        equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (57 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_READ_FILE_USN_DATA                        equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (58 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_WRITE_USN_CLOSE_RECORD                    equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (59 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_EXTEND_VOLUME                             equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (60 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_QUERY_USN_JOURNAL                         equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (61 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_DELETE_USN_JOURNAL                        equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (62 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_MARK_HANDLE                               equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (63 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_SIS_COPYFILE                              equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (64 shl 2) or METHOD_BUFFERED or (FILE_ANY_ACCESS shl 14)
FSCTL_SIS_LINK_FILES                            equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (65 shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
FSCTL_HSM_MSG                                   equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (66 shl 2) or METHOD_BUFFERED or (FILE_READWRITE_ACCESS shl 14)
FSCTL_NSS_CONTROL                               equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (67 shl 2) or METHOD_BUFFERED or (FILE_WRITE_ACCESS shl 14)
FSCTL_HSM_DATA                                  equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (68 shl 2) or METHOD_NEITHER or (FILE_READWRITE_ACCESS shl 14)
FSCTL_RECALL_FILE                               equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (69 shl 2) or METHOD_NEITHER or (FILE_ANY_ACCESS shl 14)
FSCTL_NSS_RCONTROL                              equ     (FILE_DEVICE_FILE_SYSTEM shl 16) or (70 shl 2) or METHOD_BUFFERED or (FILE_READ_ACCESS shl 14)

USN_PAGE_SIZE                                   equ     01000H

USN_REASON_DATA_OVERWRITE                       equ     000000001H
USN_REASON_DATA_EXTEND                          equ     000000002H
USN_REASON_DATA_TRUNCATION                      equ     000000004H
USN_REASON_NAMED_DATA_OVERWRITE                 equ     000000010H
USN_REASON_NAMED_DATA_EXTEND                    equ     000000020H
USN_REASON_NAMED_DATA_TRUNCATION                equ     000000040H
USN_REASON_FILE_CREATE                          equ     000000100H
USN_REASON_FILE_DELETE                          equ     000000200H
USN_REASON_EA_CHANGE                            equ     000000400H
USN_REASON_SECURITY_CHANGE                      equ     000000800H
USN_REASON_RENAME_OLD_NAME                      equ     000001000H
USN_REASON_RENAME_NEW_NAME                      equ     000002000H
USN_REASON_INDEXABLE_CHANGE                     equ     000004000H
USN_REASON_BASIC_INFO_CHANGE                    equ     000008000H
USN_REASON_HARD_LINK_CHANGE                     equ     000010000H
USN_REASON_COMPRESSION_CHANGE                   equ     000020000H
USN_REASON_ENCRYPTION_CHANGE                    equ     000040000H
USN_REASON_OBJECT_ID_CHANGE                     equ     000080000H
USN_REASON_REPARSE_POINT_CHANGE                 equ     000100000H
USN_REASON_STREAM_CHANGE                        equ     000200000H
USN_REASON_CLOSE                                equ     080000000H

USN_DELETE_FLAG_DELETE                          equ     000000001H
USN_DELETE_FLAG_NOTIFY                          equ     000000002H
USN_DELETE_VALID_FLAGS                          equ     000000003H

USN_SOURCE_DATA_MANAGEMENT                      equ     000000001H
USN_SOURCE_AUXILIARY_DATA                       equ     000000002H
USN_SOURCE_REPLICATION_MANAGEMENT               equ     000000004H

VOLUME_IS_DIRTY                                 equ     000000001H
VOLUME_UPGRADE_SCHEDULED                        equ     000000002H

FILESYSTEM_STATISTICS_TYPE_NTFS                 equ     1
FILESYSTEM_STATISTICS_TYPE_FAT                  equ     2

FILE_SET_ENCRYPTION                             equ     000000001H
FILE_CLEAR_ENCRYPTION                           equ     000000002H
STREAM_SET_ENCRYPTION                           equ     000000003H
STREAM_CLEAR_ENCRYPTION                         equ     000000004H

MAXIMUM_ENCRYPTION_VALUE                        equ     000000004H

ENCRYPTION_FORMAT_DEFAULT                       equ     001H
COMPRESSION_FORMAT_SPARSE                       equ     04000H

COPYFILE_SIS_LINK                               equ     00001H
COPYFILE_SIS_REPLACE                            equ     00002H
COPYFILE_SIS_FLAGS                              equ     00003H

NSS_CONTROL_MARK                                equ     1
NSS_CONTROL_UNMARK                              equ     2
NSS_CONTROL_ISNSSFILE                           equ     4

IOCTL_VOLUME_BASE                               equ     'V'
IOCTL_VOLUME_GET_VOLUME_DISK_EXTENTS            equ     (IOCTL_VOLUME_BASE shl 16) or (0 shl 2)or METHOD_BUFFEREDOR (FILE_ANY_ACCESS shl 14)

STORAGE_PRIORITY_HINT_SUPPORTED                 equ     00001H

;======================================== Structures ======================================;
struct STORAGE_DEVICE_NUMBER
    DeviceType      dd ?
    DeviceNumber    dd ?
    PartitionNumber dd ?
ends

struct STORAGE_BUS_RESET_REQUEST
    PathId db ?
ends

struct PREVENT_MEDIA_REMOVAL
    PreventMediaRemoval dd ?
ends

struct TAPE_STATISTICS
    Version                dd ?
    iFlags                 dd ?
    RecoveredWrites        LARGE_INTEGER
    UnrecoveredWrites      LARGE_INTEGER
    RecoveredReads         LARGE_INTEGER
    UnrecoveredReads       LARGE_INTEGER
    CompressionRatioReads  db ?
    CompressionRatioWrites db ?
ends

struct TAPE_GET_STATISTICS
    Operation dd ?
ends

struct DISKINFO
    Cylinders            LARGE_INTEGER
    MediaType            dd ?
    TracksPerCylinder    dd ?
    SectorsPerTrack      dd ?
    BytesPerSector       dd ?
    NumberMediaSides     dd ?
    MediaCharacteristics dd ?
ends

struct REMOVABLEDISKINFO
    Cylinders            LARGE_INTEGER
    MediaType            dd ?
    TracksPerCylinder    dd ?
    SectorsPerTrack      dd ?
    BytesPerSector       dd ?
    NumberMediaSides     dd ?
    MediaCharacteristics dd ?
ends

struct SCSIINFORMATION
    MediumType  db ?
    DensityCode db ?
ends

struct TAPEINFO
    MediaType            dd ?
    MediaCharacteristics dd ?
    CurrentBlockSize     dd ?
    BusType              dd ?
    ScsiInformation      SCSIINFORMATION
ends

struct DEVICE_MEDIA_INFO
    union
        DiskInfo          DISKINFO
        RemovableDiskInfo REMOVABLEDISKINFO
        TapeInfo          TAPEINFO
    ends
ends

struct GET_MEDIA_TYPES
    DeviceType     dd ?
    MediaInfoCount dd ?
    MediaInfo      DEVICE_MEDIA_INFO
ends

struct STORAGE_PREDICT_FAILURE
    PredictFailure dd ?
    VendorSpecific rb 512
ends

if ~defined STORAGE_ADAPTER_DESCRIPTOR
    struct STORAGE_ADAPTER_DESCRIPTOR
        Version               dd ?
        Size                  dd ?
        MaximumTransferLength dd ?
        MaximumPhysicalPages  dd ?
        AlignmentMask         dd ?
        AdapterUsesPio        db ?
        AdapterScansDown      db ?
        CommandQueueing       db ?
        AcceleratedTransfer   db ?
        BusType               db ?
        BusMajorVersion       dw ?
        BusMinorVersion       dw ?
    ends
end if

struct STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR
    Version                       dd ?
    Size                          dd ?
    BytesPerCacheLine             dd ?
    BytesOffsetForCacheAlignment  dd ?
    BytesPerLogicalSector         dd ?
    BytesPerPhysicalSector        dd ?
    BytesOffsetForSectorAlignment dd ?
ends

struct STORAGE_MINIPORT_DESCRIPTOR
    Version              dd ?
    Size                 dd ?
    Portdriver           dd ?
    LUNResetSupported    db ?
    TargetResetSupported db ?
ends

struct STORAGE_IDENTIFIER
    CodeSet        dd ?
    Type           dd ?
    IdentifierSize dw ?
    NextOffset     dw ?
    Association    dd ?
    Identifier     db ?
ends

struct STORAGE_DEVICE_ID_DESCRIPTOR
    Version             dd ?
    Size                dd ?
    NumberOfIdentifiers dd ?
    Identifiers         db ?
ends

struct STORAGE_GET_BC_PROPERTIES_OUTPUT
    MaximumRequestsPerPeriod dd ?
    MinimumPeriod            dd ?
    MaximumRequestSize       dq ?
    EstimatedTimePerRequest  dd ?
    NumOutStandingRequests   dd ?
    RequestSize              dq ?
ends

struct STORAGE_ALLOCATE_BC_STREAM_INPUT
    Version           dd ?
    RequestsPerPeriod dd ?
    Period            dd ?
    RetryFailures     db ?
    Discardable       db ?
    Reserved1         rb 2
    AccessType        dd ?
    AccessMode        dd ?
ends

struct STORAGE_ALLOCATE_BC_STREAM_OUTPUT
    RequestSize            dq ?
    NumOutStandingRequests dd ?
ends

struct STORAGE_PRIORITY_HINT_SUPPORT
    SupportFlags dd ?
ends

struct STORAGE_MEDIA_SERIAL_NUMBER_DATA
    Reserved           dw ?
    SerialNumberLength dw ?
    SerialNumber       db ?
ends

struct STORAGE_READ_CAPACITY
    Version        dd ?
    Size           dd ?
    BlockLength    dd ?
    NumberOfBlocks LARGE_INTEGER
    DiskLength     LARGE_INTEGER
ends

struct STORAGE_WRITE_CACHE_PROPERTY
    Version                    dd ?
    Size                       dd ?
    WriteCacheType             dd ?
    _WriteCacheEnabled         dd ?
    _WriteCacheChangeable      dd ?
    _WriteThroughSupported     dd ?
    FlushCacheSupported        db ?
    UserDefinedPowerProtection db ?
    NVCacheEnabled             db ?
ends

struct PR_IN
    ServiceAction    db ?
    Reserved1        db ?
    AllocationLength dw ?
ends

struct PR_OUT
    ServiceAction    db ?
    Type             db ?
    Scope            db ?
    ParameterList    db ?
ends

struct PERSISTENT_RESERVE_COMMAND
    Version                  dd ?
    Size                     dd ?
    union
        pr_in PR_IN
        pr_out PR_OUT
    ends
ends

struct FORMAT_PARAMETERS
    MediaType           dd ?
    StartCylinderNumber dd ?
    EndCylinderNumber   dd ?
    StartHeadNumber     dd ?
    EndHeadNumber       dd ?
ends

struct FORMAT_EX_PARAMETERS
    MediaType           dd ?
    StartCylinderNumber dd ?
    EndCylinderNumber   dd ?
    StartHeadNumber     dd ?
    EndHeadNumber       dd ?
    FormatGapLength     dw ?
    SectorsPerTrack     dw ?
    SectorNumber        dw ?
ends

struct DISK_GEOMETRY
    Cylinders         dq ?
    MediaType         dd ?
    TracksPerCylinder dd ?
    SectorsPerTrack   dd ?
    BytesPerSector    dd ?
ends

struct PARTITION_INFORMATION
    StartingOffset      dq ?
    PartitionLength     dq ?
    HiddenSectors       dd ?
    PartitionNumber     dd ?
    PartitionType       db ?
    BootIndicator       dd ?
    RecognizedPartition dd ?
    RewritePartition    dd ?
ends

struct SET_PARTITION_INFORMATION
    PartitionType db ?
ends

SET_PARTITION_INFORMATION_MBR fix SET_PARTITION_INFORMATION

struct DRIVE_LAYOUT_INFORMATION
    PartitionCount dd ?
    Signature      dd ?
    PartitionEntry PARTITION_INFORMATION
ends

struct VERIFY_INFORMATION
    StartingOffset dq ?
    Length         dd ?
ends

struct REASSIGN_BLOCKS
    Reserved    dw ?
    Count       dw ?
    BlockNumber dd ?
ends

struct DISK_CONTROLLER_NUMBER
    ControllerNumber dd ?
    DiskNumber       dd ?
ends

struct VOLUME_COMPRESSION_STATE
    CompressNewFiles dd ?
ends

struct PARTITION_INFORMATION_GPT
    PartitionType GUID
    PartitionId   GUID
    Attributes    dq ?
    Name          rw 36
ends

SET_PARTITION_INFORMATION_GPT fix PARTITION_INFORMATION_GPT

struct PARTITION_INFORMATION_MBR
    PartitionType       db ?
    BootIndicator       db ?
    RecognizedPartition db ?
    HiddenSectors       dd ?
ends

struct SET_PARTITION_INFORMATION_EX
    PartitionStyle dd ?
    union
        Mbr SET_PARTITION_INFORMATION_MBR
        Gpt SET_PARTITION_INFORMATION_GPT
    ends
ends

struct CREATE_DISK_GPT
    DiskId            GUID
    MaxPartitionCount dd ?
ends

struct CREATE_DISK_MBR
    Signature dd ?
ends

struct CREATE_DISK
    PartitionStyle          dd ?
    union
        Mbr CREATE_DISK_MBR
        Gpt CREATE_DISK_GPT
    ends
ends

struct GET_LENGTH_INFORMATION
    Length  LARGE_INTEGER
ends

struct PARTITION_INFORMATION_EX
    PartitionStyle   dd ?
    StartingOffset   LARGE_INTEGER
    PartitionLength  LARGE_INTEGER
    PartitionNumber  dd ?
    RewritePartition db ?
    union
        Mbr PARTITION_INFORMATION_MBR
        Gpt PARTITION_INFORMATION_GPT
    ends
ends

struct DRIVE_LAYOUT_INFORMATION_GPT
    DiskId               GUID
    StartingUsableOffset LARGE_INTEGER
    UsableLength         LARGE_INTEGER
    MaxPartitionCount    dd ?
ends

struct DRIVE_LAYOUT_INFORMATION_MBR
    Signature dd ?
ends

struct DRIVE_LAYOUT_INFORMATION_EX
    PartitionStyle dd ?
    PartitionCount dd ?
    union
        Mbr PARTITION_INFORMATION_MBR
        Gpt PARTITION_INFORMATION_GPT
    ends
    PartitionEntry PARTITION_INFORMATION_EX
ends

struct DISK_INT13_INFO
    DriveSelect     dw ?
    MaxCylinders    dd ?
    SectorsPerTrack dw ?
    MaxHeads        dw ?
    NumberDrives    dw ?
ends

struct DISK_EX_INT13_INFO
    ExBufferSize      dw ?
    ExFlags           dw ?
    ExCylinders       dd ?
    ExHeads           dd ?
    ExSectorsPerTrack dd ?
    ExSectorsPerDrive dq ?
    ExSectorSize      dw ?
    ExReserved        dw ?
ends

struct DISK_DETECTION_INFO
    SizeOfDetectInfo dd ?
    DetectionType    dd ?
    union
        struct
            Int13    DISK_INT13_INFO
            ExInt13  DISK_EX_INT13_INFO
        ends
    ends
ends

struct MBR
    Signature   dd ?
    CheckSum    dd ?
ends

struct GPT
    DiskId      GUID
ends

struct DISK_PARTITION_INFO
    SizeOfPartitionInfo dd ?
    PartitionStyle      dd ?
    union
        Mbr MBR
        Gpt GPT
    ends
ends

struct DISK_GEOMETRY_EX
    Geometry DISK_GEOMETRY
    DiskSize LARGE_INTEGER
    Data     db ?
ends

if ~defined DISK_CONTROLLER_NUMBER
    struct DISK_CONTROLLER_NUMBER
        ControllerNumber dd ?
        DiskNumber       dd ?
    ends
end if

struct SCALARPREFETCH
    Minimum               dw ?
    Maximum               dw ?
    MaximumBlocks         dw ?
ends

struct BLOCKPREFECTH
    Minimum               dw ?
    Maximum               dw ?
ends

struct DISK_CACHE_INFORMATION
    ParametersSavable             dd ?
    ReadCacheEnabled              dd ?
    _WriteCacheEnabled            dd ?
    ReadRetentionPriority         dd ?
    WriteRetentionPriority        dd ?
    DisablePrefetchTransferLength dw ?
    PrefetchScalar                dd ?
    union
        ScalarPrefetch SCALARPREFETCH
        BlockPrefetch BLOCKPREFECTH
    ends
ends

struct DISK_GROW_PARTITION
    PartitionNumber dd ?
    BytesToGrow     dq ?
ends

struct HISTOGRAM_BUCKET
    Reads  dd ?
    Writes dd ?
ends

struct DISK_HISTOGRAM
    DiskSize     dq ?
    Start        dq ?
    _End         dq ?
    Average      dq ?
    AverageRead  dq ?
    AverageWrite dq ?
    Granularity  dd ?
    Size         dd ?
    ReadCount    dd ?
    WriteCount   dd ?
    Histogram    dd ?
ends

struct DISK_PERFORMANCE
    BytesRead           dq ?
    BytesWritten        dq ?
    ReadTime            dq ?
    WriteTime           dq ?
    IdleTime            dq ?
    ReadCount           dd ?
    WriteCount          dd ?
    QueueDepth          dd ?
    SplitCount          dd ?
    QueryTime           dq ?
    StorageDeviceNumber dd ?
    StorageManagerName  rw 8
ends

struct DISK_RECORD
    ByteOffset     dq ?
    StartTime      dq ?
    EndTime        dq ?
    VirtualAddress dd ?
    NumberOfBytes  dd ?
    DeviceNumber   db ?
    ReadRequest    dd ?
ends

struct DISK_LOGGING
    Function      db ?
    BufferAddress dd ?
    BufferSize    dd ?
ends

struct ENUM_BIN_TYPES
    RequestSize     db ?
    RequestLocation db ?
ends

struct BIN_RANGE
    StartValue dq ?
    Length     dq ?
ends

struct PERF_BIN
    NumberOfBins dd ?
    TypeOfBin    dd ?
    BinsRanges   BIN_RANGE
ends

struct BIN_COUNT
    BinRange BIN_RANGE
    BinCount dd ?
ends

struct BIN_RESULTS
    NumberOfBins dd ?
    BinCounts    BIN_RANGE
ends

struct GETVERSIONINPARAMS
    bVersion      db ?
    bRevision     db ?
    bReserved     db ?
    bIDEDeviceMap db ?
    fCapabilities dd ?
    dwReserved    rd 4
ends

struct IDEREGS
    bFeaturesReg     db ?
    bSectorCountReg  db ?
    bSectorNumberReg db ?
    bCylLowReg       db ?
    bCylHighReg      db ?
    bDriveHeadReg    db ?
    bCommandReg      db ?
    bReserved        db ?
ends

struct SENDCMDINPARAMS
    cBufferSize  dd ?
    irDriveRegs  IDEREGS
    bDriveNumber db ?
    bReserved    rb 3
    dwReserved   rd 4
    bBuffer      db ?
ends

struct DRIVERSTATUS
    bDriverError db ?
    bIDEError    db ?
    bReserved    rb 2
    dwReserved   rd 2
ends

struct SENDCMDOUTPARAMS
    cBufferSize  dd ?
    DriverStatus DRIVERSTATUS
    bBuffer      db ?
ends

struct CHANGER_ELEMENT
    ElementType    dd ?
    ElementAddress dd ?
ends

struct CHANGER_ELEMENT_LIST
    Element          CHANGER_ELEMENT
    NumberOfElements dd ?
ends

struct GET_CHANGER_PARAMETERS
    Size                       dd ?
    NumberTransportElements    dw ?
    NumberStorageElements      dw ?
    NumberCleanerSlots         dw ?
    NumberIEElements           dw ?
    NumberDataTransferElements dw ?
    NumberOfDoors              dw ?
    FirstSlotNumber            dw ?
    FirstDriveNumber           dw ?
    FirstTransportNumber       dw ?
    FirstIEPortNumber          dw ?
    FirstCleanerSlotAddress    dw ?
    MagazineSize               dw ?
    DriveCleanTimeout          dd ?
    Features0                  dd ?
    Features1                  dd ?
    MoveFromTransport          db ?
    MoveFromSlot               db ?
    MoveFromIePort             db ?
    MoveFromDrive              db ?
    ExchangeFromTransport      db ?
    ExchangeFromSlot           db ?
    ExchangeFromIePort         db ?
    ExchangeFromDrive          db ?
    LockUnlockCapabilities     db ?
    PositionCapabilities       db ?
    Reserved1                  rb 2
    Reserved2                  rd 2
ends

struct CHANGER_PRODUCT_DATA
    VendorId     rb VENDOR_ID_LENGTH
    ProductId    rb PRODUCT_ID_LENGTH
    Revision     rb REVISION_LENGTH
    SerialNumber rb SERIAL_NUMBER_LENGTH
    DeviceType   db ?
ends

struct CHANGER_SET_ACCESS
    Element CHANGER_ELEMENT
    Control dd ?
ends

struct CHANGER_READ_ELEMENT_STATUS
    ElementList   CHANGER_ELEMENT_LIST
    VolumeTagInfo dd ?
ends

struct CHANGER_ELEMENT_STATUS
    Element           CHANGER_ELEMENT
    SrcElementAddress CHANGER_ELEMENT
    Flags             dd ?
    ExceptionCode     dd ?
    TargetId          db ?
    Lun               db ?
    Reserved          dw ?
    PrimaryVolumeID   rb MAX_VOLUME_ID_SIZE
    AlternateVolumeID rb MAX_VOLUME_ID_SIZE
ends

struct CHANGER_INITIALIZE_ELEMENT_STATUS
    ElementList CHANGER_ELEMENT_LIST
    BarCodeScan dd ?
ends

struct CHANGER_SET_POSITION
    Transport   CHANGER_ELEMENT
    Destination CHANGER_ELEMENT
    Flip        dd ?
ends

struct CHANGER_EXCHANGE_MEDIUM
    Transport    CHANGER_ELEMENT
    Source       CHANGER_ELEMENT
    Destination1 CHANGER_ELEMENT
    Destination2 CHANGER_ELEMENT
    Flip1        dd ?
    Flip2        dd ?
ends

struct CHANGER_MOVE_MEDIUM
    Transport   CHANGER_ELEMENT
    Source      CHANGER_ELEMENT
    Destination CHANGER_ELEMENT
    Flip        dd ?
ends

struct CHANGER_SEND_VOLUME_TAG_INFORMATION
    StartingElement  CHANGER_ELEMENT
    ActionCode       dd ?
    VolumeIDTemplate rb MAX_VOLUME_TEMPLATE_SIZE
ends

struct READ_ELEMENT_ADDRESS_INFO
    NumberOfElements dd ?
    ElementStatus    CHANGER_ELEMENT_STATUS
ends

struct PATHNAME_BUFFER
    PathNameLength dd ?
    Name           dw ?
ends

struct FSCTL_QUERY_FAT_BPB_BUFFER
    First0x24BytesOfBootSector rb 024H
ends

if ~defined NTFS_VOLUME_DATA_BUFFER
    struct NTFS_VOLUME_DATA_BUFFER
        VolumeSerialNumber           dq ?
        NumberSectors                dq ?
        TotalClusters                dq ?
        FreeClusters                 dq ?
        TotalReserved                dq ?
        BytesPerSector               dd ?
        BytesPerCluster              dd ?
        BytesPerFileRecordSegment    dd ?
        ClustersPerFileRecordSegment dd ?
        MftValidDataLength           dq ?
        MftStartLcn                  dq ?
        Mft2StartLcn                 dq ?
        MftZoneStart                 dq ?
        MftZoneEnd                   dq ?
    ends
end if

struct NTFS_EXTENDED_VOLUME_DATA
    ByteCount    dd ?
    MajorVersion dw ?
    MinorVersion dw ?
ends

struct STARTING_LCN_INPUT_BUFFER
    StartingLcn dq ?
ends

struct VOLUME_BITMAP_BUFFER
    StartingLcn dq ?
    BitmapSize  dq ?
    Buffer      db ?
ends

struct STARTING_VCN_INPUT_BUFFER
    StartingVcn dq ?
ends

struct EXTENTS
    NextVcn dq ?
    Lcn     dq ?
ends

struct RETRIEVAL_POINTERS_BUFFER
    ExtentCount dd ?
    StartingVcn dq ?
    Extents EXTENTS
ends

struct NTFS_FILE_RECORD_INPUT_BUFFER
    FileReferenceNumber dq ?
ends

struct NTFS_FILE_RECORD_OUTPUT_BUFFER
    FileReferenceNumber dq ?
    FileRecordLength    dd ?
    FileRecordBuffer    db ?
ends

struct MOVE_FILE_DATA
    FileHandle   dd ?
    StartingVcn  dq ?
    StartingLcn  dq ?
    ClusterCount dd ?
ends

if defined APP_WIN64
    struct MOVE_FILE_DATA32
        FileHandle   dd ?
        StartingVcn  dq ?
        StartingLcn  dq ?
        ClusterCount dd ?
    ends

    struct MARK_HANDLE_INFO32
        UsnSourceInfo dd ?
        VolumeHandle  dd ?
        HandleInfo    dd ?
    ends
end if

struct HFS_INFORMATION_BUFFER
    FinderInfo rb 32
ends

struct FIND_BY_SID_DATA
    Restart dd ?
    Sid     SID
ends

struct MFT_ENUM_DATA
    StartFileReferenceNumber dq ?
    LowUsn                   dq ?
    HighUsn                  dq ?
ends

struct CREATE_USN_JOURNAL_DATA
    MaximumSize     dq ?
    AllocationDelta dq ?
ends

struct READ_USN_JOURNAL_DATA
    StartUsn          dq ?
    ReasonMask        dd ?
    ReturnOnlyOnClose dd ?
    Timeout           dq ?
    BytesToWaitFor    dq ?
    UsnJournalID      dq ?
ends

struct USN_RECORD
    RecordLength              dd ?
    MajorVersion              dw ?
    MinorVersion              dw ?
    FileReferenceNumber       dq ?
    ParentFileReferenceNumber dq ?
    Usn                       dq ?
    TimeStamp                 dq ?
    Reason                    dd ?
    SourceInfo                dd ?
    SecurityId                dd ?
    FileAttributes            dd ?
    FileNameLength            dq ?
    FileNameOffset            dw ?
    FileName                  dw ?
ends

struct USN_JOURNAL_DATA
    UsnJournalID    dq ?
    FirstUsn        dq ?
    NextUsn         dq ?
    LowestValidUsn  dq ?
    MaxUsn          dq ?
    MaximumSize     dq ?
    AllocationDelta dq ?
ends

struct DELETE_USN_JOURNAL_DATA
    UsnJournalID dq ?
    DeleteFlags  dd ?
ends

struct MARK_HANDLE_INFO
    UsnSourceInfo dd ?
    VolumeHandle  dd ?
    HandleInfo    dd ?
ends

struct BULK_SECURITY_TEST_DATA
    DesiredAccess dd ?
    SecurityIds   dd ?
ends

struct FILESYSTEM_STATISTICS
    FileSystemType          dw ?
    Version                 dw ?
    SizeOfCompleteStructure dd ?
    UserFileReads           dd ?
    UserFileReadBytes       dd ?
    UserDiskReads           dd ?
    UserFileWrites          dd ?
    UserFileWriteBytes      dd ?
    UserDiskWrites          dd ?
    MetaDataReads           dd ?
    MetaDataReadBytes       dd ?
    MetaDataDiskReads       dd ?
    MetaDataWrites          dd ?
    MetaDataWriteBytes      dd ?
    MetaDataDiskWrites      dd ?
ends

struct FAT_STATISTICS
    CreateHits          dd ?
    SuccessfulCreates   dd ?
    FailedCreates       dd ?
    NonCachedReads      dd ?
    NonCachedReadBytes  dd ?
    NonCachedWrites     dd ?
    NonCachedWriteBytes dd ?
    NonCachedDiskReads  dd ?
    NonCachedDiskWrites dd ?
ends

struct EXFAT_STATISTICS
    CreateHits          dd ?
    SuccessfulCreates   dd ?
    FailedCreates       dd ?
    NonCachedReads      dd ?
    NonCachedReadBytes  dd ?
    NonCachedWrites     dd ?
    NonCachedWriteBytes dd ?
    NonCachedDiskReads  dd ?
    NonCachedDiskWrites dd ?
ends

struct MFTWRITESUSERLEVEL
    Write                          dw ?
    Create                         dw ?
    SetInfo                        dw ?
    Flush                          dw ?
ends

struct BITMAPWRITESUSERLEVEL
    Write                          dw ?
    Create                         dw ?
    SetInfo                        dw ?
ends

struct MFTBITMAPWRITESUSERLEVEL
    Write                          dw ?
    Create                         dw ?
    SetInfo                        dw ?
    Flush                          dw ?
ends

struct ALLOCATE
    Calls                          dd ?
    Clusters                       dd ?
    Hints                          dd ?
    RunsReturned                   dd ?
    HintsHonored                   dd ?
    HintsClusters                  dd ?
    Cache                          dd ?
    CacheClusters                  dd ?
    CacheMiss                      dd ?
    CacheMissClusters              dd ?
ends

struct NTFS_STATISTICS
    LogFileFullExceptions              dd ?
    OtherExceptions                    dd ?
    MftReads                           dd ?
    MftReadBytes                       dd ?
    MftWrites                          dd ?
    MftWriteBytes                      dd ?
    MftWritesUserLevel                 MFTWRITESUSERLEVEL
    MftWritesFlushForLogFileFull       dw ?
    MftWritesLazyWriter                dw ?
    MftWritesUserRequest               dw ?
    Mft2Writes                         dd ?
    Mft2WriteBytes                     dd ?
    Mft2WritesUserLevel                MFTWRITESUSERLEVEL
    Mft2WritesFlushForLogFileFull      dw ?
    Mft2WritesLazyWriter               dw ?
    Mft2WritesUserRequest              dw ?
    RootIndexReads                     dd ?
    RootIndexReadBytes                 dd ?
    RootIndexWrites                    dd ?
    RootIndexWriteBytes                dd ?
    BitmapReads                        dd ?
    BitmapReadBytes                    dd ?
    BitmapWrites                       dd ?
    BitmapWriteBytes                   dd ?
    BitmapWritesFlushForLogFileFull    dw ?
    BitmapWritesLazyWriter             dw ?
    BitmapWritesUserRequest            dw ?
    BitmapWritesUserLevel              BITMAPWRITESUSERLEVEL
    MftBitmapReads                     dd ?
    MftBitmapReadBytes                 dd ?
    MftBitmapWrites                    dd ?
    MftBitmapWriteBytes                dd ?
    MftBitmapWritesFlushForLogFileFull dw ?
    MftBitmapWritesLazyWriter          dw ?
    MftBitmapWritesUserRequest         dw ?
    MftBitmapWritesUserLevel           MFTBITMAPWRITESUSERLEVEL
    UserIndexReads                     dd ?
    UserIndexReadBytes                 dd ?
    UserIndexWrites                    dd ?
    UserIndexWriteBytes                dd ?
    LogFileReads                       dd ?
    LogFileReadBytes                   dd ?
    LogFileWrites                      dd ?
    LogFileWriteBytes                  dd ?
    Allocate                           ALLOCATE
ends

struct EXTENDEDINFOSTRUCT
    BirthVolumeId rb 16
    BirthObjectId rb 16
    DomainId      rb 16
ends

struct FILE_OBJECTID_BUFFER
    ObjectId               rb 16
    union
        ExtendedInfostruct EXTENDEDINFOSTRUCT
        ExtendedInfo       rb 48
    ends
ends

struct FILE_SET_SPARSE_BUFFER
    SetSparse dd ?
ends

struct FILE_ZERO_DATA_INFORMATION
    FileOffset      dq ?
    BeyondFinalZero dq ?
ends

struct FILE_ALLOCATED_RANGE_BUFFER
    FileOffset dq ?
    Length     dq ?
ends

struct ENCRYPTION_BUFFER
    EncryptionOperation dd ?
    Private             db ?
ends

struct DECRYPTION_STATUS_BUFFER
    NoEncryptedStreams dd ?
ends

struct REQUEST_RAW_ENCRYPTED_DATA
    FileOffset dq ?
    Length     dd ?
ends

struct ENCRYPTED_DATA_INFO
    StartingFileOffset         dq ?
    OutputBufferOffset         dd ?
    BytesWithinFileSize        dd ?
    BytesWithinValidDataLength dd ?
    CompressionFormat          dw ?
    DataUnitShift              db ?
    ChunkShift                 db ?
    ClusterShift               db ?
    EncryptionFormat           db ?
    NumberOfDataBlocks         dw ?
    DataBlockSize              dd ?
ends

struct SI_COPYFILE
    SourceFileNameLength      dd ?
    DestinationFileNameLength dd ?
    Flags                     dd ?
    FileNameBuffer            dw ?
ends

struct NSS_CONTROL
    code  dd ?
    param dd ?
ends

struct DISK_EXTENT
    DiskNumber     dd ?
    StartingOffset dq ?
    ExtentLength   dq ?
ends

struct VOLUME_DISK_EXTENTS
    NumberOfDiskExtents dd ?
    Extents             DISK_EXTENT
ends

end if ;WINIOCTL_INC
